import sublime_plugin
import subprocess
import os


class ViewOnGithubCommand(sublime_plugin.TextCommand):

    def check_output(self, command, cwd):
        r"""Run command with arguments and return its output as a byte string.

        Backported from Python 2.7 as it's implemented as pure python on stdlib.

        >>> check_output(['/usr/bin/python', '--version'])
        Python 2.6.2
        """

        process = subprocess.Popen(command, shell=True, stdout=subprocess.PIPE, cwd=cwd)
        output, unused_err = process.communicate()
        retcode = process.poll()
        if retcode:
            cmd = command
            error = subprocess.CalledProcessError(retcode, cmd)
            error.output = output
            raise error
        return output

    def run(self, edit):
        absfile = self.view.file_name()

        if absfile == None:
            return

        cwd = os.path.dirname(absfile)
        git_root = self.check_output("git rev-parse --show-toplevel", cwd).strip()
        github_repo = self.check_output("git remote -v 2> /dev/null | grep github | awk '{ print $2 }' | sed -e 's/git@github.com:\\(.*\\).git/\\1/' | head -n 1", cwd).strip()
        branch = self.check_output("git branch | sed -e '/^[^*]/d' -e 's/* \\(.*\)/\\1/' -e 's/#/%23/'", cwd).strip()
        relfile = os.path.relpath(absfile, git_root)

        url = "https://github.com/" + github_repo + "/blob/" + branch + "/" + relfile

        subprocess.call('open ' + url, shell=True)
